<?php

function mongolantern_activation() {
  return true;
}

function mongolantern_deactivation() {    
  return true;
}


function mongolantern_footer_notice(){        
  echo "<div id='msp-helloworld-notice'>Hello, I'm your custom notice</div>";
}


function mongolantern_menu() {
  //  add_menu_page('MongoLantern - MongoDB Fulltext Search Engine', 'MongoLantern Search', 'add_users', MONGOLANTERN_DIR.'/settings.php', '',   MONGOLANTERN_URL.'resources/images/logo.png', 21);
  add_menu_page('MongoLantern - MongoDB Fulltext Search Engine', 'MongoLantern Search', 'add_users', MONGOLANTERN_DIR.'/settings.php', 'showSettingsForm',   MONGOLANTERN_URL.'resources/images/logo.png');
  add_action('admin_init', 'mongolantern_settings_init');
}


//  add settings link to plugin list
function mongolantern_settings_link($actions, $file) {
  if(false !== strpos($file, 'mongolantern'))
    $actions['settings'] = '<a href="admin.php?page=mongolantern/settings.php">Settings</a>';

  return $actions; 
}


//  override default search from mongolantern and use custom mongolantern search
function monlantern_wp_default_search_handler() {
  if(is_search()) {
    $keyword = get_search_query();    

    $mongoConn = new Mongo(get_option('mongolantern_database_host').':'.get_option('mongolantern_database_port'));
    $MongoDB = $mongoConn->selectDb(get_option('mongolantern_database_database'));
    
    $search = new MongoLanternQuery();
    $search->indexName = get_option('mongolantern_index_name');
    $search->Connect($MongoDB);
    
    $parser = new MongoLanternQueryParser();
    $parser->setQueryTerm($keyword);
    
    $search->setQuery($parser);
    
    $search->setSortMode('RANK');
    
    $search->debug = false;
    $resultList = $search->Execute($limit);
    
    $GLOBALS['mongolantern_postsIdList'] = array();
    foreach($resultList as $docInfo) {
      $GLOBALS['mongolantern_postsIdList'][] = (int) $docInfo['documentID'];
    }
    
    //  add custom where filter to query with list of post ids
    add_filter('posts_where', 'mongolantern_filter_where');
    
    // to error
    if($error == true)
      $query->is_404 = true;
  }
}

function mongolantern_filter_where($where) {
  global $wpdb;
	$where .= " AND ".$wpdb->prefix."posts.ID IN (".implode(',', $GLOBALS['mongolantern_postsIdList']).")";
	return $where;
}



